;Vyganto Simkaus pirmoji namu darbo uzduotis nr. 30
.model small
.stack 100h
.data
    pradine_zinute        DB "Iveskite simboliu eilute", 13, 10, "$"   
	tuscia_eilute         DB 13, 10, "$"
	pabaigos_zinute       DB "Programos darbas baigtas.$"
	daliklis              DB 10d
	ilgisSK               DW ?
	kairys_skliaustas     DB "(ilgis $"
	desinys_skliaustas    DB ")$" 
	buferis               DB 255   
	ilgis                 DB "$"
	nera_simboliu_zinute  DB " (ilgis 0)$"
	
.code
start:
    MOV AX, @data
    MOV DS, AX
    
	MOV AH, 09h	                      		
	MOV DX, offset pradine_zinute	      ;Isveda teksta, kuris praso ivesti simboliu eilute	
	INT	21h	
	 
	MOV AH, 0Ah        
    MOV DX, offset buferis                ;Nurodoma, kad bus skaitoma i buferi
    INT 21h 
    
	MOV AH, 09h	                      		
	MOV DX, offset tuscia_eilute	      ;Iveda simboliu eilute
	INT	21h
	
    MOV BL, 0                             ;BL registre laikysim simboliu skaiciu
	LEA SI, [buferis+2]                   ;I SI nustatom nuskaitytos_eilutes pradzia                             
	xor CX, CX                            ;Uznulina CX (griezta disjukcija)
    mov CL, [ilgis]                       ;I CL ikelia eilutes ilgio reiksme
    CMP CL, 0                             ;Lygina CL su 0
    JE nera_simboliu                      ;Jei CL (ivestos eilutes ilgis)=0
    XOR AL, AL                            ;Nulinam AL reiksme tam, kad prasidejus skaitymui LODSB nuskaitytu i svaru AL
	JMP nuskaitymas
	
	
nuskaitymas:	
	LODSB                                 ;I AL iraso is DS:[SI] paimta bita ir pakeicia SI reiksme
	INC BL                                ;Padidina BL+1 - skaiciuoja simobliu skaiciu
	CMP AL, ' '                           ;Lygina ar nuskaitytas simbolis yra tarpas, jei taip, reiskia reikia ji ignoruoti
	JE tarpas                             ;Pereina i tarpas dali ir ten praleidzia tarpa bei pereina i nauja eilute
    CMP AL, '$'                           ;Lygina ar nuskaitytas simbolis yra $, jei taip, tuomet eilute pasibaige
    JE eilutes_pabaiga                    ;Pereina i kita dali
	
	MOV DL, AL                            ;I DL irasom nuskaityta simboli
	MOV AH, 02h                           ;Isvedam ta nuskaityta simboli
	INT 21h 
    LOOP nuskaitymas                      ;Ciklo kartojimas
 
eilutes_pabaiga:
	MOV CX, 0                             ;Del visa ko padarom CX=0, kad nebeveiktu nuskaitymo ciklas
	DEC BL                                ;IS BL atimam vieneta, nes BL skaiciavo simboliu skaiciu ir priskaiciavo $ zenkla
	MOV AX, BX                            ;I AX irasom simboliu skaiciu
    JMP eilutes_ilgis
    
tarpas:
	MOV AH, 09h	                      		
	MOV DX, offset tuscia_eilute	      ;Persikeliam i nauja eilute	
	INT	21h
	JMP nuskaitymas
	
eilutes_ilgis:
	DIV daliklis                          ;Dalinam AX is desimties. Sveikoji dalis keliauja i AL, o liekana keliauja i AH
    XOR BX, BX                            ;Nusinulinam BX kitam naudojimui
    ADD AH, 30h                           ;Prie liekanos pridedame 30 [pastebime, kad 0, 1, 2... atitinkamai ascii lentelej lygus 30h, 31h, 32h...]
    MOV BL, AH                            ;I BL irasom liekana
    PUSH BX                               ;Liekana imetam i steka
    XOR AH, AH                            ;Nulinam AH darbui
    INC CX                                ;Padidiname CX vienetu - skaiciuojam, kiek skaicius turi skaitmenu
    CMP AL, 0                             ;Tikrinam ar BL(sveikoji dalis) lygi 0
    JA eilutes_ilgis                      ;Jei AL nelygu 0, tada kartojam cikla 
	
	MOV AH, 09h	                      		
	MOV DX, offset tuscia_eilute	      ;Persikeliam i nauja eilute	
	INT	21h	

	MOV AH, 09h	                      		
	MOV DX, offset kairys_skliaustas      ;(ilgis ..) isvedimui isvedam ( sklaiusta  
	INT	21h
	
    JMP ilgio_isvedimas                   ;Jei lygi nuliui, vadinasi skaicius jau sutvarkytas. Steke tvarkingai sudelioti skaiciai
	
ilgio_isvedimas:
    POP ilgisSK                           ;I ilgisSK is steko irasom pirmaji skaiciu
    MOV AH, 02h                           ;Spausdinam ta skaiciu
    MOV DX, [ilgisSK]
    INT 21h
    LOOP ilgio_isvedimas                  ;Is CX atimamas vienetas ir spausdinamas kitas skaitmuo
  
 	MOV AH, 09h	                      		
	MOV DX, offset desinys_skliaustas     ;Cia desinys skliaustas po uzrasyto skaiciaus	  
	INT	21h	 
    
    JMP pabaiga                           ;Pereina i pabaiga
    
nera_simboliu:
   	MOV AH, 09h	                      		
	MOV DX, offset tuscia_eilute	      ;Persikeliam i nauja eilute	
	INT	21h	

	MOV AH, 09h	                      		
	MOV DX, offset nera_simboliu_zinute   ;Paraso (ilgis 0) 
	INT	21h
	
	JMP pabaiga                           ;Pereina i pabaiga
        
pabaiga:            
	MOV AH, 09h	                      		
	MOV DX, offset tuscia_eilute	      ;Persikeliam i nauja eilute	
	INT	21h	
	  
 	MOV AH, 09h                      
    MOV DX, offset pabaigos_zinute        ;Isvesime pabaigos teksta, kad vartotojas suprastu, jog programa baigta
    INT 21h 
  
 	MOV	ah, 4Ch	                          ;Baigiam darba	 
	INT	21h
	
end start